/**
 * JOnAS: Java(TM) Open Application Server
 * Copyright (C) 2009 Bull S.A.S.
 * Contact: jonas-team@ow2.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 * --------------------------------------------------------------------------
 * $Id: BundleActionCommand.as 20454 2010-10-12 15:52:44Z lglglglg $
 * --------------------------------------------------------------------------
 */

package org.ow2.jonas.admin.osgiconsole.command
{
	import com.adobe.cairngorm.commands.ICommand;
	import com.adobe.cairngorm.control.CairngormEvent;

	import mx.controls.Alert;
	import mx.rpc.IResponder;
	import mx.rpc.events.ResultEvent;

	import org.ow2.jonas.admin.osgiconsole.business.BundleActionDelegate;
	import org.ow2.jonas.admin.osgiconsole.event.BundleActionEvent;
	import org.ow2.jonas.admin.osgiconsole.event.BundleInfoEvent;
	import org.ow2.jonas.admin.osgiconsole.model.OSGIConsoleModelLocator;
	import org.ow2.jonas.admin.osgiconsole.vo.BundleActionResultVO;

	public class BundleActionCommand implements ICommand,IResponder
	{
		public function BundleActionCommand(){
		}
		public function execute(event:CairngormEvent):void{
			var e:BundleActionEvent=event as BundleActionEvent;
			var delegate:BundleActionDelegate=OSGIConsoleModelLocator.getInstance().bundleActionDelegate;
			delegate.responder=this;
			delegate.bundleAction(e.getActionType(),e.getSelectedIndices());
		}
		public function result(event:Object):void{
			var resultEvent:ResultEvent=event as ResultEvent;
			var bundleActionResult:BundleActionResultVO = resultEvent.result as BundleActionResultVO;
			if(bundleActionResult.error==true)
			{
				Alert.show(bundleActionResult.message);
				new BundleInfoEvent(BundleInfoEvent.EVENT_GET_BUNDLE_LIST+OSGIConsoleModelLocator.getInstance().componentID).dispatch();
			}
		}
		public function fault(info:Object):void{
			Alert.show(info.result);
		}

	}
}